VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Mdulo para buscar archivos - Ejemplo"
   ClientHeight    =   4875
   ClientLeft      =   165
   ClientTop       =   825
   ClientWidth     =   9870
   LinkTopic       =   "Form1"
   ScaleHeight     =   4875
   ScaleWidth      =   9870
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "Resultado"
      Height          =   2415
      Index           =   1
      Left            =   5760
      TabIndex        =   11
      Top             =   120
      Width           =   3975
      Begin VB.ListBox lstResult 
         Height          =   1620
         Left            =   120
         TabIndex        =   12
         Top             =   360
         Width           =   3615
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Datos de bsqueda"
      Height          =   4455
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5535
      Begin VB.PictureBox Picture1 
         BorderStyle     =   0  'None
         Height          =   4095
         Left            =   120
         ScaleHeight     =   4095
         ScaleWidth      =   5295
         TabIndex        =   1
         Top             =   240
         Width           =   5295
         Begin VB.CommandButton cmdStop 
            Caption         =   "Detener"
            Enabled         =   0   'False
            Height          =   375
            Left            =   1440
            TabIndex        =   13
            Top             =   2760
            Width           =   1095
         End
         Begin VB.CommandButton cmdFind 
            Caption         =   "Buscar"
            Height          =   375
            Left            =   120
            TabIndex        =   10
            Top             =   2760
            Width           =   1215
         End
         Begin VB.TextBox txtFileName 
            Height          =   375
            Left            =   120
            TabIndex        =   9
            Top             =   2280
            Width           =   4935
         End
         Begin VB.TextBox txtExtension 
            Height          =   375
            Left            =   120
            TabIndex        =   7
            Text            =   "*.bas;*.frm;*.cls"
            Top             =   1440
            Width           =   4935
         End
         Begin VB.CommandButton cmdBrowserFolder 
            Caption         =   "..."
            Height          =   375
            Left            =   4440
            TabIndex        =   5
            Top             =   480
            Width           =   615
         End
         Begin VB.TextBox txtPath 
            Height          =   375
            Left            =   120
            TabIndex        =   4
            Top             =   480
            Width           =   4215
         End
         Begin VB.CheckBox chkSearchSubDir 
            Caption         =   "Buscar en subdirectorios"
            Height          =   255
            Left            =   120
            TabIndex        =   2
            Top             =   3360
            Value           =   1  'Checked
            Width           =   2175
         End
         Begin VB.Label Label3 
            AutoSize        =   -1  'True
            BackStyle       =   0  'Transparent
            Caption         =   "Texto en el nombre del archivo"
            Height          =   195
            Left            =   120
            TabIndex        =   8
            Top             =   2040
            Width           =   2190
         End
         Begin VB.Label Label2 
            AutoSize        =   -1  'True
            BackStyle       =   0  'Transparent
            Caption         =   "Extensiones ( No incluir nada para buscar todas o usar *.*)"
            Height          =   195
            Left            =   120
            TabIndex        =   6
            Top             =   1080
            Width           =   4935
         End
         Begin VB.Label Label1 
            AutoSize        =   -1  'True
            BackStyle       =   0  'Transparent
            Caption         =   "Buscar en :"
            Height          =   195
            Left            =   120
            TabIndex        =   3
            Top             =   240
            Width           =   810
         End
      End
   End
   Begin VB.Menu mnuFile 
      Caption         =   "Archivo"
      Begin VB.Menu mnuExit 
         Caption         =   "Salir"
      End
   End
   Begin VB.Menu mnuAyuda 
      Caption         =   "Ayuda"
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' ----------------------------------------------------------------------------------
' -- Descripcin : Buscar archivos - Ejemplo
' -- Autor       : Luciano Lodola - http://www.recursosvisualbasic.com.ar/
' ----------------------------------------------------------------------------------

' \\ -- Declaraciones
' ---------------------------------------------------------------------------

' -- Apis para tomar la apariencia de  windows
Private Declare Function SetErrorMode Lib "kernel32" (ByVal wMode As Long) As Long
Private Declare Sub InitCommonControls Lib "Comctl32" ()

' \\ -- Variables
' ---------------------------------------------------------------------------

Private WithEvents cFind As cFindFiles
Attribute cFind.VB_VarHelpID = -1

' -----------------------------------------------------------------------------------------------
' \\ -- Evento cuando finaliza la bsqueda
' -----------------------------------------------------------------------------------------------
Private Sub cFind_EndSearch()

    Dim xFile As Variant
    For Each xFile In cFind.ColFiles
        lstResult.AddItem xFile
    Next
    cmdFind.Caption = "Buscar"
    Me.MousePointer = 0
    Frame1(1).Caption = cFind.FilesCount & " archivos encontrados"
    cmdFind.Enabled = True
    cmdStop.Enabled = False
End Sub
' -----------------------------------------------------------------------------------------------
' \\ -- Evento que recibe los archivos mientras se busca
' -----------------------------------------------------------------------------------------------
Private Sub cFind_GetFile(ByVal sFileName As String)
    Frame1(1).Caption = CStr(cFind.FilesCount) & " archivos encontrados"
End Sub

' -----------------------------------------------------------------------------------------------
' \\ -- Evento de inicio de bsqueda
' -----------------------------------------------------------------------------------------------

Private Sub cFind_InitSearch()
    Me.MousePointer = vbHourglass
    lstResult.Clear
    cmdFind.Enabled = False
    cmdStop.Enabled = True
End Sub
' -----------------------------------------------------------------------------------------------
' \\ -- Checkbox para buscar en subdirs
' -----------------------------------------------------------------------------------------------

Private Sub chkSearchSubDir_Click()
    cFind.SearchSubDirs = Abs(chkSearchSubDir.Value)
End Sub
' -----------------------------------------------------------------------------------------------
' \\ -- Botn para seleccionar path de bsqueda
' -----------------------------------------------------------------------------------------------
Private Sub cmdBrowserFolder_Click()
    txtPath.Text = cFind.BrowseForFolder(Me.hWnd, "Seleccionar carpeta o una unidad")
End Sub
' -----------------------------------------------------------------------------------------------
' \\ -- Botn buscar
' -----------------------------------------------------------------------------------------------
Private Sub cmdFind_Click()
    If txtPath.Text = "" Then
        MsgBox "seleccione una unidad o directorio donde buscar", vbExclamation
        Exit Sub
    End If
    ' -- Buscar
    Call cFind.Find(txtPath.Text, txtExtension, txtFileName, ePartial)
End Sub
' -----------------------------------------------------------------------------------------------
' \\ -- Botn para detener la bsqueda
' -----------------------------------------------------------------------------------------------

Private Sub cmdStop_Click()
    cFind.StopSearch
End Sub


' -----------------------------------------------------------------------------------------------
' \\ -- Inicio del form
' -----------------------------------------------------------------------------------------------
Private Sub Form_Load()
    ' -- Crear nueva instancia del mdulo
    Set cFind = New cFindFiles
    ' -- Incluir subdirs
    With cFind
        .SearchSubDirs = Abs(chkSearchSubDir)
    End With
End Sub
Private Sub Form_Initialize()
    Call SetErrorMode(2)
    Call InitCommonControls
End Sub

' -----------------------------------------------------------------------------------------------
' \\ -- Redimensionar
' -----------------------------------------------------------------------------------------------

Private Sub Form_Resize()
    On Local Error Resume Next
    With Frame1(1)
        .Width = (Me.ScaleWidth - .Left) - 100
        .Height = (Me.ScaleHeight - .Top) - 100
    End With
    With Frame1(0)
        .Height = Frame1(1).Height
    End With
    With lstResult
        lstResult.Width = (Frame1(1).Width - .Left) - 150
        .Height = Frame1(1).Height - .Top
    End With

End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set cFind = Nothing
End Sub

Private Sub mnuExit_Click()
    Unload Me
End Sub
